<?php

namespace Ardent\Undercurrent\View;

use Ardent\Undercurrent\AppConfig;

class BaseView implements ViewInterface
{
    private ViewHelper $helper;

    public function __construct(
        private readonly string $path,
        private readonly array  $data = [],
        private ?string         $extends = null,
    )
    {
    }

    public function render(AppConfig $config, ViewHelper $helper): string
    {
        $this->helper = $helper;
        $path = $config->getTemplatePath() . $this->path;

        ob_start();
        include $path;
        $output = ob_get_clean();
        if ($this->extends) {
            return (new BaseView($this->extends, $this->data + ['slot' => $output]))->render($config, $helper);
        }

        return $output;
    }
}